diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
index c9db163d6b95637012d72e42577828ef81ef1b9d..0a0b6e77526fe0dfd57cf6eac4426317d3959e7c 100644
--- a/.gitlab-ci.yml
+++ b/.gitlab-ci.yml
@@ -1,5 +1,6 @@
 stages:
   - clean
+  - build
   - run_tests
 
 clean-spack:
@@ -17,6 +18,22 @@ clean-spack:
     - when: never
 
 
+build-only:
+  stage: build
+  script:
+    - ./examples/00_build_only.sh
+  tags:
+    - slurm.meteo.physik.lmu.de
+  variables:
+    SRUN_OPTIONS: "--time 04:00:00 --mem 18G -n 4 -c 2"
+
+  artifacts:
+    name: build-only-logs
+    when: always
+    paths:
+      - ./autosubmit/**/tmp
+    expire_in: 7 days
+
 
 real-from-ideal:
   stage: run_tests
@@ -62,6 +79,22 @@ real-from-dwd-ana:
   artifacts:
     name: real-from-dwd-ana-logs
     when: always
+    paths:
+      - ./autosubmit/**/tmp
+    expire_in: 7 days
+
+real-from-dwd-ana-B6:
+  stage: run_tests
+  script:
+    - ./examples/02_real-from-dwd-ana_B6.sh
+  tags:
+    - slurm.meteo.physik.lmu.de
+  variables:
+    SRUN_OPTIONS: "--time 04:00:00 --mem 64G -n 16 -c 2"
+
+  artifacts:
+    name: real-from-dwd-ana-B6-logs
+    when: always
     paths:
       - ./autosubmit/**/tmp
     expire_in: 7 days
\ No newline at end of file
diff --git a/examples/00_build_only.sh b/examples/00_build_only.sh
new file mode 100755
index 0000000000000000000000000000000000000000..320ef660fd37823df8c322bc5934b50337363cf1
--- /dev/null
+++ b/examples/00_build_only.sh
@@ -0,0 +1,21 @@
+#!/bin/bash
+#######################################################################################################################
+# Variables that are required to define the test case
+EXPID="bo000"
+ICON_CASE="build_only"
+ICON_VERSION="2.6.5-nwp0"
+PLATFORM="LOCAL"
+EXTRA_NAMELIST=""
+EXTRA_CONFIGURATION=""
+
+#######################################################################################################################
+set -euo pipefail
+
+# Get path to the script directory
+SCRIPT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" >/dev/null 2>&1 && pwd)"
+
+# Import the function run_autoicon_example
+source ${SCRIPT_DIR}/example_utils.sh
+
+# Setup and run the experiment
+run_autoicon_example "$EXPID" "$ICON_CASE" "$ICON_VERSION" "$PLATFORM" "${EXTRA_NAMELIST}" "${EXTRA_CONFIGURATION}"
diff --git a/examples/02_real-from-dwd-ana_B6.sh b/examples/02_real-from-dwd-ana_B6.sh
new file mode 100755
index 0000000000000000000000000000000000000000..23da15417a2162883fd33a8cbda8b2384d40081d
--- /dev/null
+++ b/examples/02_real-from-dwd-ana_B6.sh
@@ -0,0 +1,21 @@
+#!/bin/bash
+#######################################################################################################################
+# Variables that are required to define the test case
+EXPID="rfdaB6"
+ICON_CASE="real-from-dwd-ana"
+ICON_VERSION="w2w-B6"
+PLATFORM="LOCAL"
+EXTRA_NAMELIST=""
+EXTRA_CONFIGURATION=""
+
+#######################################################################################################################
+set -euo pipefail
+
+# Get path to the script directory
+SCRIPT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" >/dev/null 2>&1 && pwd)"
+
+# Import the function run_autoicon_example
+source ${SCRIPT_DIR}/example_utils.sh
+
+# Setup and run the experiment
+run_autoicon_example "$EXPID" "$ICON_CASE" "$ICON_VERSION" "$PLATFORM" "${EXTRA_NAMELIST}" "${EXTRA_CONFIGURATION}"
diff --git a/spack_repo/packages/icon-nwp/package.py b/spack_repo/packages/icon-nwp/package.py
index 695a80c6bb3127e874bdf34183a3f86ddd38f562..3f3785ee9d6b1644168ad0ea0b221939c225bb08 100644
--- a/spack_repo/packages/icon-nwp/package.py
+++ b/spack_repo/packages/icon-nwp/package.py
@@ -164,7 +164,12 @@ class IconNwp(Package):
         ]
 
         if "+debug" in self.spec:
-            options.append(f"ICON_FCFLAGS={ICON_FCFLAGS} -fbacktrace -fbounds-check -fstack-protector-all -finit-real=nan -finit-integer=-2147483648 -finit-character=127 -w -O2")
+            if self.spec.satisfies("%gcc"):
+                options.append(f"ICON_FCFLAGS={ICON_FCFLAGS} -fbacktrace -fbounds-check -fstack-protector-all -finit-real=nan -finit-integer=-2147483648 -finit-character=127 -w -O2")
+            elif self.spec.satisfies("%intel"):
+                options.append(f"ICON_FCFLAGS={ICON_FCFLAGS} -traceback -check bounds -init=snan -O2")
+            else:
+                raise AssertionError("Compiler does not satisfy gcc nor intel.")
         else:
             options.append(f"ICON_FCFLAGS={ICON_FCFLAGS} -O3")
 
diff --git a/templates/common/run_icon.sh b/templates/common/run_icon.sh
index 1d7ecc6a51a96a2cd0391e44bfe5e3a6335fa8ae..a72b0c827d9c2fe15010b2bb8e5dd16e8e4ed7d9 100644
--- a/templates/common/run_icon.sh
+++ b/templates/common/run_icon.sh
@@ -16,8 +16,15 @@ cd ${RUNDIR}
 load_spack "%spack.init%" "%spack.root%" "%spack.url%" "%spack.branch%" "%spack.externals%" "%spack.compiler%" "%spack.disable_local_config%" "%spack.user_cache_path%" "%spack.user_config_path%" "%spack.upstreams%"
 
 
+# Get proper load command.
+SPACK_BUILD_ICON="%ICON.BUILD_CMD%"
+SPACK_LOAD_ICON="%ICON.LOAD_CMD%"
+
+if [ "${SPACK_LOAD_ICON}" == "build_cmd" ]; then
+  SPACK_LOAD_ICON=${SPACK_BUILD_ICON}
+fi
 # Load icon module
-spack load --first icon-nwp@%ICON_VERSION%
+spack load --first ${SPACK_LOAD_ICON}
 
 # Set environment variable for eccodes-dwd definitions:
 source ${WORKDIR}/eccodes_defs.env